<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SizeThrottle.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.throttle</a> &gt; <span class="el_source">SizeThrottle.java</span></div><h1>SizeThrottle.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.throttle;

import java.util.concurrent.Semaphore;
import java.util.function.Consumer;

import io.gitlab.littlesaints.protean.configuration.Config;
import io.gitlab.littlesaints.protean.configuration.Defaults;

/**
 * A size based {@link Throttle}. It limits the maximum number of messages in the processing workflow / pipeline.
 *
 * @author Varun Anand
 * @since 1.0
 */
public class SizeThrottle implements Throttle {

	public static final String TYPE = &quot;protean::throttle::size&quot;;

	public static class Registrar implements io.gitlab.littlesaints.protean.resources.Registrar {
<span class="nc" id="L40">		public Registrar() {</span>
<span class="nc" id="L41">			REGISTRY.register(TYPE, SizeThrottle::new);</span>
<span class="nc" id="L42">		}</span>

		@Override
		public String toString() {
<span class="nc" id="L46">			return &quot;SizeThrottle::Registrar&quot;;</span>
		}
	}

	private final Semaphore permits;

	private final Consumer&lt;Boolean&gt; listener;

	interface Keys {
		String THRESHOLD = &quot;threshold&quot;;
	}

<span class="nc" id="L58">	private SizeThrottle(Config config, Consumer&lt;Boolean&gt; listener) {</span>
<span class="nc" id="L59">		final int threshold = config.getOrDefault(Keys.THRESHOLD, Defaults.BUFFER);</span>
<span class="nc" id="L60">		this.permits = new Semaphore(threshold);</span>
		//TODO implement listener
<span class="nc" id="L62">		this.listener = listener;</span>
<span class="nc" id="L63">	}</span>

	@Override
	public void acquire() {
		while (true) {
			try {
<span class="nc" id="L69">				permits.acquire();</span>
<span class="nc" id="L70">				break;</span>
<span class="nc" id="L71">			} catch (InterruptedException e) {</span>
<span class="nc" id="L72">				e.printStackTrace();</span>
<span class="nc" id="L73">			}</span>
		}
<span class="nc" id="L75">	}</span>

	@Override
	public void release() {
<span class="nc" id="L79">		permits.release();</span>
<span class="nc" id="L80">	}</span>

	@Override
	public boolean isActive() {
<span class="nc bnc" id="L84" title="All 2 branches missed.">		return permits.availablePermits() &gt; 0;</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>